Halaman ini menjelaskan cara mengamankan instance App Engine dengan Identity-Aware Proxy (IAP).
Sebelum memulai
Untuk mengaktifkan IAP untuk App Engine, lakukan hal berikut:
Gunakan project konsol Google Cloud dengan penagihan diaktifkan.
Pastikan project tersebut termasuk dalam organisasi Google Cloud jika Anda ingin menggunakan klien OAuth terkelola Google default. Jika Anda tidak memiliki organisasi, Anda dapat membuatnya. Untuk mempelajari manfaat penggunaan klien OAuth kustom, lihat Mengonfigurasi klien OAuth kustom untuk App Engine. Klien OAuth yang dikelola Google hanya mengizinkan akses ke pengguna internal.
Siapkan instance App Engine Anda, jika Anda belum melakukannya. Untuk mengetahui panduan lengkapnya, lihat Men-deploy ke App Engine.
Mengaktifkan IAP
Konsol
Jika project Anda bukan milik organisasi, Anda harus menggunakan kredensial OAuth kustom.
If you haven't configured your project's OAuth consent screen, you'll be prompted to do so. To configure your OAuth consent screen, see Setting up your OAuth consent screen.
Setting up IAP access
-
Go to the
Identity-Aware Proxy page.
Go to the Identity-Aware Proxy page - Select the project you want to secure with IAP.
- Select the checkbox next to the resource you want to grant access to.
- On the right side panel, click Add principal.
-
In the Add principals dialog that appears, enter the email addresses of groups or
individuals who should have the IAP-secured Web App User role for the project.
The following kinds of principals can have this role:
- Google Account: user@gmail.com
- Google Group: admins@googlegroups.com
- Service account: server@example.gserviceaccount.com
- Google Workspace domain: example.com
Make sure to add a Google Account that you have access to.
- Select Cloud IAP > IAP-secured Web App User from the Roles drop-down list.
- Click Save.
Turning on IAP
-
On the Identity-Aware Proxy page, under Applications,
find the application you want to restrict
access to. To turn on IAP for a resource,
-
In the Turn on IAP window that appears, click Turn On to
confirm that you want IAP to secure your resource. After you turn on
IAP, it requires login credentials for all connections to your load balancer.
Only principals with the IAP-Secured Web App User (
roles/iap.httpsResourceAccessor) role on the project will be given access.
gcloud
Before you set up your project and IAP, you need an up-to-date version of the gcloud CLI. For instructions on how to install the gcloud CLI, see Install the gcloud CLI.
-
To authenticate, use the Google Cloud CLI and run the following command.
gcloud auth login - Click the URL that appears and sign in.
- After you sign in, copy the verification code that appears and paste it in the command line.
-
Run the following command to specify the project that contains the applications that you want to protect with IAP.
gcloud config set project PROJECT_ID -
To enable IAP, run the following command.
gcloud iap web enable --resource-type=app-engine --versions=version -
Add principals who should have the IAP-secured Web App user role to the project.
gcloud projects add-iam-policy-binding PROJECT_ID \ --member=PRINCIPAL_IDENTIFIER \ --role=roles/iap.httpsResourceAccessor- Replace PROJECT_ID with your project ID.
- Replace PRINCIPAL_IDENTIFIER with the necessary principals. This can be a
type of domain, group, serviceAccount, or user. For example,
user:myemail@example.com.
After you enable IAP, you can use the gcloud CLI to modify the
IAP access policy using the IAM role
roles/iap.httpsResourceAccessor. Learn more about
managing roles and permissions.
API
Run the following command to prepare a
settings.jsonfile.cat << EOF > settings.json { "iap": { "enabled":true } } EOFRun the following command to enable IAP.
curl -X PATCH \ -H "Authorization: Bearer $(gcloud auth print-access-token)" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d @settings.json \ "https://appengine.googleapis.com/v1/apps/PROJECT_ID?updateMask=iap"
After you enable IAP, you can use the Google Cloud CLI to modify the
IAP access policy using the IAM role
roles/iap.httpsResourceAccessor. Learn more about
managing roles and permissions.
Anda dapat mengaktifkan IAP di layanan App Engine dalam project Anda. Untuk membuat beberapa layanan dapat diakses secara publik dan memerlukan autentikasi untuk layanan lainnya, Anda dapat menggunakan tingkat akses yang berbeda di seluruh layanan.
Untuk mempelajari lebih lanjut, lihat Mengelola akses dengan IAP.
Untuk membuat layanan dapat diakses secara publik, berikan peran IAP-secured Web App User ke
allAuthenticatedUsers.
Menguji autentikasi pengguna
Setelah peran diberikan, akun utama dapat mengakses aplikasi dengan melakukan autentikasi dengan IAP. Akses URL aplikasi dari Akun Google yang diberi peran IAP-secured Web App User (
roles/iap.httpsResourceAccessor).Untuk menguji akses, buka jendela Samaran di Chrome, akses URL aplikasi, dan login saat diminta. Pengguna yang diberi peran IAP-secured Web App User (
roles/iap.httpsResourceAccessor) dan berhasil mengautentikasi dapat mengakses aplikasi. Pengguna yang tidak diberi peran yang diperlukan atau gagal mengautentikasi tidak dapat mengakses aplikasi.